/**
 * This class provids methods to check dependency and track those checks for this char category.
 * 
 * @author Boris Serdar
 * 
 */
public class CharCategory extends Category {

	private char c;

	/**
	 * This constructor initializes the variable c.
	 * 
	 * @param c
	 *            value for variable c.
	 */
	public CharCategory(char c) {
		this.c = c;
	}

	/**
	 * This method calculates dependency of the current object (this) with another one. It supports the dependsOn
	 * method.
	 * Pre-condition of this method is, that the elem variable is instance of the same class as the current
	 * object (this)!
	 * 
	 * @param elem
	 *            Element for which dependency with "this" is checked.
	 * @return true if the c variable is equal for both "this" and "that" objects, false otherwise.
	 */
	protected boolean dependsOnCalc(Category elem) {
		CharCategory x = (CharCategory) elem;

		if (this.c == x.c) {
			return true;
		} else {
			return false;
		}
	}

	/**
	 * This method creates a string representation of the current object (this).
	 * 
	 * @return representative string.
	 */
	public String toString() {
		return "Char c: " + c;
	}
}
