/**
 * This interface provides a method to check dependency of two objects.
 * 
 * @author Stefan Klbl
 * 
 * @param <A>
 *            Type parameter for the elements for which dependency is checked.
 */
public interface Dependent<A extends Dependent<A>> {

	/**
	 * This method checks dependency of the current object (this) with another one.
	 * 
	 * @param elem
	 *            Element for which dependency with "this" is checked.
	 * @return true if dependency exists, false otherwise.
	 */
	public boolean dependsOn(A elem);
}
