/**
 * This class provids methods to check dependency and track those checks for this integer category.
 * 
 * @author Boris Serdar
 * 
 */
public class IntCategory extends Category {

	private int a, b;

	/**
	 * This constructor initializes the variables a and b with new values.
	 * 
	 * @param a
	 *            value for variable a.
	 * @param b
	 *            value for variable b.
	 */
	public IntCategory(int a, int b) {
		this.a = a;
		this.b = b;
	}

	/**
	 * This method calculates dependency of the current object (this) with another one. It supports the dependsOn
	 * method.
	 * Pre-condition of this method is, that the elem variable is instance of the same class as the current
	 * object (this)!
	 * 
	 * @param elem
	 *            Element for which dependency with "this" is checked.
	 * @return true if the variable a is equal for both "this" and "that" objects, and the b variable of "this" is bigger or
	 *         equal to the b variable of "that", false otherwise.
	 */
	protected boolean dependsOnCalc(Category elem) {
		IntCategory x = (IntCategory) elem;

		if (this.a == x.a && this.b >= x.b) {
			return true;
		} else {
			return false;
		}
	}

	/**
	 * This method creates a string representation of the current object (this).
	 * 
	 * @return representative string for this object.
	 */
	public String toString() {
		return "Integer a: " + a + ", Integer b: " + b;
	}
}
