import java.lang.String;

/**
 * This class provides objects with a specific representative string.
 * 
 * @author Marvin Hanke
 * 
 */
public class Prefixed implements Dependent<Prefixed> {

	private String readme;

	/**
	 * This constructor initializes the readme variable with the new text.
	 * 
	 * @param text
	 */
	public Prefixed(String text) {
		this.readme = text;
	}

	/**
	 * This method checks dependency of the current object (this) with another one.
	 * 
	 * @param elem
	 *            Element for which dependency with "this" is checked.
	 * @return true if the readme variable of "that" is equal to the readme variable of "this", false otherwise.
	 */
	public boolean dependsOn(Prefixed that) {
		return readme.startsWith(that.readme);
	}
}
