/*
 * Work-sharing:
 * Marvin Hanke: AList, Prefixed
 * Stefan Klbl: SList, Test, Iterable_Iterator, Dependent
 * Boris Serdar: DList, Category, IntCategory, CharCategory
 */

import java.util.Iterator;

/**
 * This class provides a testing environment for task 5 of object-oriented programming.
 * 
 * @author Stefan Klbl
 * 
 */
public class Test {

	/**
	 * Executable main program.
	 * 
	 * @param args
	 */
	public static void main(String[] args) {

		
		SList<Integer> test = new SList<Integer>();
		test.add(1);
		test.add(2);
		test.add(3, 2);
		test.add(4, 2);
		test.add(5, 2);
		
		Iterator<Integer> itr = test.iterator();

		System.out.println(itr.next());
		// itr.remove();
		System.out.println(itr.next());
		// itr.remove();
		System.out.println(itr.next());
		// itr.remove();
		System.out.println(itr.next());
		// itr.remove();
		System.out.println(itr.next());
		// itr.remove();
		System.out.println(itr.next());

		System.out.println("size of list: " + test.getSize() + "\n");
		 
		test.remove(3);
		test.remove(2);
		test.remove(1);
		test.remove(1);
		test.remove(1);

		test.add(1);
		test.add(2,1);
		test.add(3,1);
		
		itr = test.iterator();
		System.out.println(itr.next());
		System.out.println(itr.next());
		System.out.println(itr.next());
		System.out.println(itr.next());
		System.out.println(itr.next());
		System.out.println(itr.next());
		
		System.out.println("size of list: " + test.getSize() + "\n");
		
		
		Prefixed p1 = new Prefixed("test 1");
		Prefixed p2 = new Prefixed("test");
		
		System.out.println(p1.dependsOn(p2));
		System.out.println(p2.dependsOn(p1));
		System.out.println("\n");
		
		IntCategory i1 = new IntCategory(1,2);
		IntCategory i2 = new IntCategory(1,3);
		IntCategory i3 = new IntCategory(2,2);
		
		CharCategory c1 = new CharCategory('a');
		CharCategory c2 = new CharCategory('b');
		CharCategory c3 = new CharCategory('c');
		
		System.out.println(i2.dependsOn(c2));
		System.out.println(i2.dependsOn(i1));
		System.out.println(i3.dependsOn(i1));
		System.out.println("\n");
		System.out.println(c1.dependsOn(c2));
		System.out.println(c3.dependsOn(c1));
		System.out.println(c1.dependsOn(i1));
		
		
		AList<Integer, String> a1 = new AList<Integer, String>();
		String[] a1string1 = {"a","b","c","d"};
		String[] a1string2 = {"e","f","g"};
		String[] a1string3 = {"h","i",};
		a1.add(11, a1string1);
		a1.add(22, a1string2);
		a1.add(33, a1string3);
		
		Iterable_Iterator<Integer, String> a1_itr = a1.iterator();
		while(a1_itr.hasNext()) {
			Iterator<String> a1_asso_itr = a1_itr.iterator();
			System.out.println();
			while(a1_asso_itr.hasNext()) {
				System.out.print(a1_asso_itr.next());
			}
			System.out.println();
			
			a1_itr.iterator();
			
			System.out.println(a1_itr.next());
		}
		
		
		DList<CharCategory, String> d1 = new DList<CharCategory, String>();
		d1.add(c1, a1string1);
		d1.add(c2, a1string2);
		d1.add(c3, a1string3);
		
		System.out.println(d1.consistent());
			
	}
}